
// NoticeClientDlg.h : header file
//

#pragma once
#include "afxcmn.h"

#include "afxwin.h"

#include "..\api\inc\EvNoticeApi.h"

#define WM_USER_LOG_MESSAGE		(WM_USER + 103)

// CNoticeClientDlg dialog
class CNoticeClientDlg : public CDialog
{
// Construction
public:
	CNoticeClientDlg(CWnd* pParent = NULL);	// standard constructor
	~CNoticeClientDlg();

// Dialog Data
	enum { IDD = IDD_NOTICECLIENT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

private:
	// α ޽   ɹ
	CStdioFile		m_fileLog;
	CStringArray	m_arOutputLog;

	// ȭ ü
	CRITICAL_SECTION m_cs;

	// ȯ BMP̹ ϱ  ޸ 
	PBYTE			m_pBmpImage;
	ULONG			m_lBmpLength;

	BOOL			m_bFirst;
	ULONG			m_lReceiveCount;


	//   Ȯ 
	BOOL			m_bRunning;
	//  ü
	CWinThread		*m_pThread;

	// ŵ   ɹ
	NOTICE_HEADER	m_Header;

	// NOTICE HANDLE
	HANDLE			m_hNoticeHandle;

    // PREFIX
    CString         m_strPrefix;

public:
	DWORD GetIPAddress(LPCTSTR lpszAddress);
	LPCTSTR GetIPAddress(DWORD dwAddress);

	BOOL UpdateResult(PNOTICE_HEADER pHeader, PBYTE pImgData, ULONG lImgLength);
	void UpdateControls();

	void LogOut(LPCTSTR lpszMsg);
	void LogOut(char *fmt, ...);
	void LogClear();

	void MakeBmpHeader(BITMAPINFOHEADER *pbmiHdr, BITMAPFILEHEADER *pbmfHdr, ULONG lWidth, ULONG lHeight);
	void YtoRGB8(PBYTE pYuvBuf, ULONG lYuvLength, PBYTE pBmpBuf, ULONG lBmpLength, ULONG lWidth, ULONG lHeight);

	void WriteRGB8(LPCTSTR lpszFileName, PNOTICE_HEADER pHeader, PBYTE pImgData, ULONG lImgLength);
	void WritePng(LPCTSTR lpszFileName, PNOTICE_HEADER pHeader, PBYTE pImgData, ULONG lImgLength);

	// ۾ 忡 ȣǴ Լ
	int Capture();

	// NOTICE ͸ ϱ  
	static UINT OnNoticeThread(LPVOID pParam);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CIPAddressCtrl m_ipaddrCtrl;
	afx_msg void OnBnClickedBtnSearch();
	afx_msg void OnBnClickedBtnConnect();
	afx_msg void OnBnClickedBtnDisconnect();
	afx_msg void OnBnClickedBtnBrowse();
	afx_msg LRESULT OnLogMessage(WPARAM wParam, LPARAM lParam);
	CString m_strLocalDirectory;
	CListBox m_listLog;
	CButton m_btnConnect;
	CButton m_btnDisconnect;
	afx_msg void OnBnClickedBtnLogdump();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedCheckMarkImage();
	afx_msg void OnBnClickedBtnOpen();
	afx_msg void OnBnClickedBtnLogclear();
	CString m_strLocalDirectory2;
	afx_msg void OnBnClickedBtnBrowse2();
	afx_msg void OnBnClickedBtnOpen2();
	BOOL m_bOverwrite;
	afx_msg void OnBnClickedCheckOverwrite();
	int m_iFileFormat;
	afx_msg void OnBnClickedRadioBitmap();
	afx_msg void OnBnClickedRadioPng();
};
