// SearchDlg.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NoticeClient.h"
#include "SearchDlg.h"


// CSearchDlg ȭ Դϴ.

IMPLEMENT_DYNAMIC(CSearchDlg, CDialog)

CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSearchDlg::IDD, pParent)
{
    m_SocketClient.SetInterface(this);
}

CSearchDlg::~CSearchDlg()
{
}

void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMB_SUBNET, m_cmbSubnet);
	DDX_Control(pDX, IDC_LIST_VISIONS, m_listVisions);
	DDX_Control(pDX, IDOK, m_btnOK);
}


BEGIN_MESSAGE_MAP(CSearchDlg, CDialog)
	ON_BN_CLICKED(IDC_BTN_SEARCH, &CSearchDlg::OnBnClickedBtnSearch)
	ON_WM_DESTROY()
	ON_CBN_SELCHANGE(IDC_CMB_SUBNET, &CSearchDlg::OnCbnSelchangeCmbSubnet)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_VISIONS, &CSearchDlg::OnLvnItemchangedListVisions)
END_MESSAGE_MAP()


// CSearchDlg ޽ óԴϴ.

BOOL CSearchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.
	m_listVisions.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);  

	// Create combo:
	GetLocalAddress();

	m_listVisions.InsertColumn(0, _T("Address"));
	m_listVisions.SetColumnWidth(0, 120);
	m_listVisions.InsertColumn(1, _T("Name"));
	m_listVisions.SetColumnWidth(1, 210);

	m_btnOK.EnableWindow(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CSearchDlg::OnOK()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	POSITION pos = m_listVisions.GetFirstSelectedItemPosition();
	if (pos)
	{
		m_strSelectAddress = m_listVisions.GetItemText(m_listVisions.GetNextSelectedItem(pos), 0);
		CDialog::OnOK();
	}
}

void CSearchDlg::OnBnClickedBtnSearch()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if ( m_SocketClient.IsOpen() )
	{
		CString strCommand = "ping";

		//  
		SockAddrIn addrBroadcast;

		// Broadcast ּҸ 
		if(GetBroadcast(addrBroadcast))
		{
			m_listVisions.DeleteAllItems();

			USES_CONVERSION;
			m_SocketClient.Write((const LPBYTE)(T2CA(strCommand)), strCommand.GetLength(), addrBroadcast);
		}
	}
	else
	{
		MessageBox("Socket is not connected");
	}
}

///////////////////////////////////////////////////////////////////////////////

void CSearchDlg::GetLocalAddress()
{
	PIP_ADAPTER_INFO pAdapterInfo;
	PIP_ADAPTER_INFO pAdapter = NULL;
	DWORD dwRetVal = 0;

	/* variables used to print DHCP time info */
	pAdapterInfo = (IP_ADAPTER_INFO *) malloc( sizeof(IP_ADAPTER_INFO) );
	ULONG ulOutBufLen = sizeof(IP_ADAPTER_INFO);

	// Make an initial call to GetAdaptersInfo to get
	// the necessary size into the ulOutBufLen variable
	if (GetAdaptersInfo( pAdapterInfo, &ulOutBufLen) == ERROR_BUFFER_OVERFLOW) 
	{
		free(pAdapterInfo);
		pAdapterInfo = (IP_ADAPTER_INFO *) malloc (ulOutBufLen); 
		if (pAdapterInfo == NULL) 
		{
			TRACE("Error allocating memory needed to call GetAdaptersinfo\n");
			return;
		}
	}

	if ((dwRetVal = GetAdaptersInfo( pAdapterInfo, &ulOutBufLen)) == NO_ERROR) 
	{
		// ޺ ڽ  ʱȭ
		m_cmbSubnet.ResetContent();

		pAdapter = pAdapterInfo;
		while (pAdapter) 
		{
			CString strAddress = pAdapter->IpAddressList.IpAddress.String;
			if(strAddress != "0.0.0.0")
			{
				m_cmbSubnet.AddString(strAddress);
			}

			pAdapter = pAdapter->Next;
		}
	}
	else 
	{
		TRACE("GetAdaptersInfo failed with error: %d\n", dwRetVal);
	}

	if (pAdapterInfo)
		free(pAdapterInfo);
}

void CSearchDlg::GetAddress(const SockAddrIn& addrIn, CString& rAddress, CString& rPort) const
{
    TCHAR szIPAddr[MAX_PATH] = { 0 };
    CSocketHandle::FormatIP(szIPAddr, MAX_PATH, addrIn);
	rAddress = szIPAddr;
	rPort.Format(_T("%d"), static_cast<int>(static_cast<UINT>(ntohs(addrIn.GetPort()))));
}

bool CSearchDlg::GetBroadcast(SockAddrIn& addrIn)
{
	// Local Address  Broadcast ּҸ 
	CString strAddr, strPort = UDP_SERVER_PORT;

	int i = m_cmbSubnet.GetCurSel();
	if(i == -1)
		return false;

	int iLen = m_cmbSubnet.GetLBTextLen(i);
	m_cmbSubnet.GetLBText(i, strAddr.GetBuffer(iLen));
	strAddr.ReleaseBuffer();

	CString strN1, strN2, strN3, strN4;
	int iStart = 0;
	strN1 = strAddr.Tokenize(".", iStart);
	strN2 = strAddr.Tokenize(".", iStart);
	strN3 = strAddr.Tokenize(".", iStart);
	strN4 = strAddr.Tokenize(".", iStart);

	CString strBroadcast = strN1+"."+strN2+"."+strN3+".255";

	return addrIn.CreateFrom(strBroadcast, strPort, AF_INET);
}

bool CSearchDlg::GetSelectAddress(CString& refAddress)
{
	int i = m_cmbSubnet.GetCurSel();
	if(i == -1)
	{
		AfxMessageBox("Select local address.");
		return false;
	}

	int iLen = m_cmbSubnet.GetLBTextLen(i);
	m_cmbSubnet.GetLBText(i, refAddress.GetBuffer(iLen));
	refAddress.ReleaseBuffer();

	return true;
}

bool CSearchDlg::ConnectLocal()
{
	if(m_SocketClient.IsOpen())
		m_SocketClient.Terminate();

	// Ŭ̾Ʈ   õ Local Address connect
	CString strLocalAddress;
	if(GetSelectAddress(strLocalAddress))
		if(!m_SocketClient.StartClient(strLocalAddress, strLocalAddress, UDP_SERVER_PORT, AF_INET, SOCK_DGRAM))
		{
			TRACE(_T("Failed to start client connection.\n"));
			return false;
		}
	
	return true;
}

///////////////////////////////////////////////////////////////////////////////

void CSearchDlg::OnDestroy()
{
	__super::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	m_SocketClient.Terminate();
}

void CSearchDlg::OnCbnSelchangeCmbSubnet()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	ConnectLocal();
}

void CSearchDlg::OnLvnItemchangedListVisions(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if (!(pNMLV->uChanged == LVIF_STATE && pNMLV->uNewState == (LVIS_SELECTED | LVIS_FOCUSED)))
	{
		m_btnOK.EnableWindow(FALSE);
        return;
	}
    
	INT nSelectItem = pNMLV->iItem;
    if (-1 == nSelectItem)
	{
		m_btnOK.EnableWindow(FALSE);
        return;
	}

	m_btnOK.EnableWindow(TRUE);

	*pResult = 0;
}


///////////////////////////////////////////////////////////////////////////////

void CSearchDlg::OnThreadBegin(CSocketHandle* pSH)
{
    ASSERT( pSH == m_SocketClient );

	CString strAddr, strPort;
	SockAddrIn sockAddr;
	m_SocketClient->GetSockName(sockAddr);
	GetAddress( sockAddr, strAddr, strPort);

	TRACE(_T("Client Running on: %s:%s\n"), strAddr, strPort);
}

void CSearchDlg::OnThreadExit(CSocketHandle* pSH)
{
    ASSERT( pSH == m_SocketClient );

	TRACE(_T("Client exit\n"));
}

void CSearchDlg::OnDataReceived(CSocketHandle* pSH, const BYTE* pbData, DWORD dwCount, const SockAddrIn& addr)
{
    ASSERT( pSH == m_SocketClient );

	CString strAddr, strPort, strText;
	USES_CONVERSION;
	LPTSTR pszText = strText.GetBuffer(dwCount + 1);
	::StringCchCopyN(pszText, dwCount + 1, A2CT(reinterpret_cast<LPCSTR>(pbData)), dwCount);
	strText.ReleaseBuffer();

	GetAddress( addr, strAddr, strPort);

	if(strText == "pong")
	{
		int iCount = m_listVisions.GetItemCount();
		m_listVisions.InsertItem(iCount, strAddr);
		m_listVisions.SetItemText(iCount, 1, "Camera");

		TRACE(strAddr + _T(" ,") + strPort + _T(" > ") + strText + _T("\n"));
	}
}

void CSearchDlg::OnConnectionDropped(CSocketHandle* pSH)
{
    ASSERT( pSH == m_SocketClient );

	TRACE(_T("Connection lost with server.\n"));
}

void CSearchDlg::OnConnectionError(CSocketHandle* pSH, DWORD dwError)
{
    ASSERT( pSH == m_SocketClient );

	_com_error err(dwError);
	TRACE(_T("Communication Error:%s\n"), err.ErrorMessage());
}

