/*++

Copyright (c) 2014 EnvyLogic Inc.  All rights reserved.

Module Name:

    EvNoticeApi.h

Abstract:

    Smart Scanner Notice Protocol API v2.0

Author:

	Jogerse
 
Environment:

    user mode only

Notes:
	

Revision History:
	
	Jogerse		2012-03-05		API  ۼ
	Jogerse		2012-06-04		  ø̼ ؼ Լ 
	Jogerse		2014-09-17		ϳ PHASE  ټ HEADER + PAYLOAD  Ŷ ϴ · 
--*/

#pragma once

#ifdef EVNOTICEAPI_EXPORTS
#define EVNOTICE_API __declspec(dllexport)
#else
#define EVNOTICE_API __declspec(dllimport)
#endif


//-------------------------------------------------------------------------------------------------------------------------------
// Definition

// ϰ  ǹ̸ 
#define	EVN_ERR_SUCCESS					( 0)	//    ȣǾ 
#define EVN_ERR_CANT_INIT				(-1)	// WSAStartup Լ ȣ⿡ 
#define	EVN_ERR_CANT_END				(-2)	// WSACleanup Լ ȣ⿡ 
#define	EVN_ERR_CANT_CONNECT			(-3)	// Ư ּҿ Ʈ  
#define	EVN_ERR_NOT_CONNECT				(-4)	//  ° ƴ
#define	EVN_ERR_UNSUCCESSFUL			(-5)	// Լ ȣ ȿ  μ ġ ̻  ϴ 
#define	EVN_ERR_WINDOW_CANT_CREATE		(-6)	// ̺Ʈ  ü 츦 ϴ  ϴ 
#define	EVN_ERR_INVALID_PARAMETER		(-7)	// ȿ  Ķͷ Լ ȣ
#define	EVN_ERR_INSUFFICIENT_RESOURCE	(-8)	// ޸𸮳 ҽ Ҵϴµ 
#define	EVN_ERR_BUFFER_EMPTY			(-9)	// NOTICE ۰  ִ.
#define	EVN_ERR_BUFFER_OVERFLOW			(-10)	// NOTICE ۸ ʰߴ.
#define EVN_ERR_OVERFLOW_PAYLOAD		(-11)	// PAYLOAD ũⰡ  ũ⸦ ʰ
#define	EVN_ERR_INVALID_HANDLE			(-12)	// μ ڵ ȿ ڵ ƴ
#define	EVN_ERR_NOTICEMGR_NOT_CREATE	(-13)	// NoticeMgr Create  ¿ 
#define EVN_ERR_NOTICEMGR_BUFFER_EMPTY	(-14)	// NoticeMgr ۰ .
#define EVN_ERR_DEVICE_CANT_THREAD		(-15)	// Socket  Thread  
#define EVN_ERR_SOCKET_READ_ERROR		(-16)	// Socket Read 
#define EVN_ERR_SOCKET_WRITE_ERROR		(-17)	// Socket Write 
#define EVN_ERR_SOCKET_DISCONNECT	    (-18)	// Socket  
#define EVN_ERR_PACKET_PHASE_MISSMATCH	(-19)	// Packet   Phase ٸ PhaseNumber Ŷ 
#define EVN_ERR_PACKET_INVALID			(-20)	// ŵ Ŷ delimiter ԰ݿ  
#define EVN_ERR_CANT_CREATE_EVENT		(-21)	// ̺Ʈ ü  
#define EVN_ERR_CANCEL_GETNOTICE        (-22)   // GetNotice  ҵǾ.
#define EVN_ERR_CANT_OPEN_PNGFILE       (-23)   // PNG Openϴ   ߻

//-------------------------------------------------------------------------------------------------------------------------------
// enumeration Declaration

//   

enum _packet_type_t {
	PACKET_TYPE_COMMAND,
	PACKET_TYPE_RESULT,
	PACKET_TYPE_IMAGE
};

enum _packet_type_command_t {
	PAYLOAD_TYPE_COMMAND_ACK	= PACKET_TYPE_COMMAND,
	PAYLOAD_TYPE_COMMAND_NACK,
	PAYLOAD_TYPE_COMMAND_RETRY,
	PAYLOAD_TYPE_COMMAND_LIVE
};

enum _packet_type_result_t {
	PAYLOAD_TYPE_RESULT_IMG		= 0,
	PAYLOAD_TYPE_RESULT_BGA_BAR,
	PAYLOAD_TYPE_RESULT_BGA_OCR,
	PAYLOAD_TYPE_RESULT_HDI,
	PAYLOAD_TYPE_RESULT_REEL,
	PAYLOAD_TYPE_RESULT_AFVI,
	PAYLOAD_TYPE_RESULT_KPCB,
	PAYLOAD_TYPE_RESULT_BGAB,
	PAYLOAD_TYPE_RESULT_BGAO,
	PAYLOAD_TYPE_RESULT_BGAOT,
	PAYLOAD_TYPE_RESULT_BRAIL,
	PAYLOAD_TYPE_RESULT_MAX
};

enum _packet_type_image_t {
	PAYLOAD_TYPE_IMAGE_Y = 0x200
};

//-------------------------------------------------------------------------------------------------------------------------------
// Structure Declaration

//   

typedef struct _NOTICE_HEADER{
	unsigned long mStart;
	unsigned long mLength;
	unsigned long mVersion;
	unsigned long mTimestamp;
	unsigned long mMillisecond;
	unsigned long mPhaseNumber;
	unsigned long mPhaseCount;
	unsigned long mPhaseIndex;
	unsigned long mType;
	unsigned long mPayloadType;
	unsigned long mPayloadLength;
	unsigned long mParameter1;
	unsigned long mParameter2;
	unsigned long mParameter3;
	unsigned long mParameter4;
	unsigned long mEnd;
} NOTICE_HEADER, *PNOTICE_HEADER;

//-------------------------------------------------------------------------------------------------------------------------------
// Function Declaration

#ifdef __cplusplus
extern "C" {
#endif


/*! 
 *	\fn		EVN_Init
 *	\brief	Socket ʱȭ
 *	\return	  ʱȭ ϿٸEVN_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
EVNOTICE_API int _stdcall EVN_Init();

/*! 
 *	\fn		EVN_End
 *	\brief	Socket Ѵ.
 */
EVNOTICE_API int _stdcall EVN_End();

/*! 
 *	\fn		EVN_GetVersion
 *	\brief	API  Ѵ.
 *	\param	*pMajor					API MAJOR 
 *	\param	*pMinor					API MINOR 
 *	\param	*pChange				API CHANGE 
 *	\return	ϸ EVN_ERR_SUCCESS Ѵ. ĶŸ NULL̸ EVN_ERR_INVALID_PARAMETER Ѵ.
 */
EVNOTICE_API int _stdcall EVN_GetVersion(int *pMajor, int *pMinor, int *pChange);

/*! 
 *	\fn		EVN_Connect
 *	\brief	μ ־ ּҿ Ʈ ³ʿ  õѴ..
 *	\param	pHandle					  Ÿ HANDLE   
 *	\param	lpszAddress				ĳ IP ּ.
 *	\param	iTimeOut				TimeOut .  
 *	\return	 ĳʿ Ǹ EVN_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
EVNOTICE_API int _stdcall EVN_Connect(HANDLE *pHandle, const char *pAddress, int iTimeOut);

/*! 
 *	\fn		EVN_Disconnect
 *	\brief	ĳʿ Ǿ ִٸ  ݴ´.
 *	\param	hHandle					EVN_Connect    Ÿ HANDLE .
 *	\return	   EVN_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
EVNOTICE_API int _stdcall EVN_Disconnect(HANDLE hHandle);

/*! 
 *	\fn		EVN_GetNotice
 *	\brief	ŵ Notice Payload о ´.
 *	\param	hHandle					EVN_Connect    Ÿ HANDLE .
 *	\param	iBlocked				  1̸ ̹   ٸ. 0̸ ̹ Ȯؼ ٷ 
 *	\param	pLength					ŵ Notice  .
 *	\param	pHeader					ŵ Notice   .
 *	\param	ppPayload				ŵ Notice Payload ͸  ޸ ͸   
 *	\param	pPayloadLength			ŵ pPayload ̸  
 *	\return	 ŵ Notice о EVN_ERR_SUCCESS ϰ, Ѵٸ
 *			׿ ´  Ѵ.
 */
EVNOTICE_API int _stdcall EVN_GetNotice(HANDLE hHandle, int iBlocked, int *pLength, PNOTICE_HEADER pHeader, unsigned char **ppPayload, int *pPayloadLength);

/*! 
 *	\fn		EVN_CancelNotice
 *	\brief	Block GetNotice ƾ Block    Ѵ.
 *	\param	hHandle					EVN_Connect    Ÿ HANDLE .
 *	\return	EVN_ERR_SUCCESS Ѵ.
 *			׿ ´  Ѵ.
 */
EVNOTICE_API int _stdcall EVN_CancelNotice(HANDLE hHandle);

/*! 
 *	\fn		EVN_IsConnect
 *	\brief	ĳʿ Ǿ ִ Ȯ
 *	\param	hHandle					EVN_Connect    Ÿ HANDLE .
 *	\return	  ȮεǸ EVN_ERR_SUCCESS ϰ, Ǿ  ʴٸ
 *			EVN_ERR_NOT_CONNECT Ѵ
 */
EVNOTICE_API int _stdcall EVN_IsConnect(HANDLE hHandle);

/*! 
 *	\fn		EVN_GetErrMsg
 *	\brief	 ڵ带 ϴ ڿ 
 *	\param	error_code				 ڵ 
 *	\return	 ڵ尪 Ʈ ִٸ ش ڿ ϰ, ٸ "IT'S NOT IN ERROR LIST" ڿ Ѵ.
 */
EVNOTICE_API char* _stdcall EVN_GetErrMsg(int error_code);

/*! 
 *	\fn		EVN_GetDateTime
 *	\brief	 Timestamp Millisecond Local Time ڿ 
 *	\param	pHeader				    ¥ ð  Header 
 *	\param	pBuf				    ȯ ڿ   
 *                                  ex) "20140924 152325.123"
 *	\param	iBufLength				 ũ
 *	\return	ȯ ϸ EVN_ERR_SUCCESS ϰ, Ѵٸ ׿ ´  ڵ尪 Ѵ.
 */
EVNOTICE_API int _stdcall EVN_GetDateTime(PNOTICE_HEADER pHeader, char *pBuf, int iBufLength);

/*! 
 *	\fn		EVN_SavePngFile
 *	\brief	 Image payload png Ϸ 
 *	\param	pFileName			      ̸
 *	\param	pHeader				     Header 
 *	\param	pPayload			     payload 
 *	\param	iPayloadLength			 payload 
 *	\return	ȯ ϸ EVN_ERR_SUCCESS ϰ, Ѵٸ ׿ ´  ڵ尪 Ѵ.
 */
EVNOTICE_API int _stdcall EVN_SavePngFile(const char *pFileName, PNOTICE_HEADER pHeader, unsigned char *pPayload, int iPayloadLength);

#ifdef __cplusplus
}
#endif
